#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  Blue

//
//
//
//
//

extern int                Fast_MA_Period  = 1;
extern ENUM_MA_METHOD     FastMaMode      = MODE_SMA;
extern ENUM_APPLIED_PRICE FastMaPrice     = PRICE_MEDIAN;
extern int                Slow_MA_Period  = 34;
extern ENUM_MA_METHOD     SlowMaMode      = MODE_SMA;
extern ENUM_APPLIED_PRICE SlowMaPrice     = PRICE_MEDIAN;
extern int                Signal_period   = 5;
extern ENUM_MA_METHOD     SignalMaMode    = MODE_LWMA; 
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = true;
extern bool               alertsEmail     = false;
extern bool               alertsNotify    = false;
extern string             soundfile       = "alert2.wav";

double      Buffer1[],
            Buffer2[],
            b2[],
            b3[],
            trend[];
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,3);
   SetIndexArrow(0,242); 
   SetIndexBuffer(0,b2);
   
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,3);
   SetIndexArrow(1,241);   //UP   225  233 241
   SetIndexBuffer(1,b3);
   SetIndexBuffer (2,Buffer1);
   SetIndexBuffer (3,Buffer2);
   SetIndexBuffer(4,trend);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) Buffer1[i] = iMA(NULL,0,Fast_MA_Period,0,FastMaMode,FastMaPrice,i) - iMA(NULL,0,Slow_MA_Period,0,SlowMaMode,SlowMaPrice,i);
   for(i=limit; i>=0; i--) Buffer2[i] = iMAOnArray(Buffer1,0,Signal_period,0,SignalMaMode,i);
   for(i=limit; i>=0; i--)
   {
      b2[i] = EMPTY_VALUE;
      b3[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
      if(Buffer1[i]>Buffer2[i]) trend[i] = 1;
      if(Buffer1[i]<Buffer2[i]) trend[i] =-1;
      
      b2[i] = EMPTY_VALUE;
      b3[i] = EMPTY_VALUE;
      if (trend[i]!= trend[i+1])
      if (trend[i] == 1)
             b3[i] = Low[i]  - iATR(NULL,0,20,i)/2;
       else  b2[i] = High[i] + iATR(NULL,0,20,i)/2;
         
   } 
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }  
return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," %SMA CrossOver ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," %SMA CrossOver "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," %SMA CrossOver " +" "+message));
             if (alertsSound)   PlaySound(soundfile);
      }
}






